## postgresql-q3c 2.0.1

=== Makefile ===
EXTENSION = q3c
EXTVERSION := $(shell grep default_version $(EXTENSION).control | \
		 sed -e "s/default_version[[:space:]]*=[[:space:]]*'\([^']*\)'/\1/")


DOCS = README.md
OBJS = dump.o q3c.o q3c_poly.o q3cube.o
MODULE_big = q3c
DATA = $(wildcard scripts/*sql)
PG_CONFIG = pg_config
SHLIB_LINK += $(filter -lm, $(LIBS))
EXTRA_CLEAN = dump.c prepare prepare.o gen_data.o \
			results/join.out results/cone.out results/ellipse.out \
			results/version.out results/poly.out results/area.out \
			gen_data
ifeq ($(Q3C_NOOPT),1)
	OPT = -O0
else
	OPT = -O3
endif
#DEBUG = -O0 -g3 -ggdb -DQ3C_DEBUG
PG_CPPFLAGS = $(DEBUG) $(OPT) -D_GNU_SOURCE -D__STDC_FORMAT_MACROS -DQ3C_VERSION='"'$(EXTVERSION)'"'
CPPFLAGS = $(CPPFLAGS) -D$(Q3CVERSION)

ifeq (, $(shell which $(PG_CONFIG)))
$(error "No pg_config in $(PATH)! Exiting...")
endif

PGXS := $(shell $(PG_CONFIG) --pgxs)
ifeq (, $(wildcard $(PGXS)))
$(error "The $(PGXS) file not found. Check your PG installation. Exiting...")
endif

include $(PGXS)
PGVERNEW := $(shell if [ $(MAJORVERSION) -ge 12 ] ; then echo N ; else echo O ; fi )

ifeq ($(PGVERNEW), N)
	PG_LIBS += -L$(shell $(PG_CONFIG) --pkglibdir)
	LIBS := $(filter-out -lpam -lxml2 -lxslt -lselinux -ledit -lgssapi_krb5, $(LIBS))
	MYBINLIBS := $(LIBS) $(PG_LIBS) -lm
else
	MYBINLIBS := $(PG_LIBS) -lm
endif

dump.c: prepare
	./prepare

prepare: prepare.o q3cube.o q3c_poly.o
	$(CC) $? $(CFLAGS) $(PG_LIBS) $(PG_LDFLAGS) $(LDFLAGS) $(MYBINLIBS) -o $@

gen_data: gen_data.c
	$(CC) $< $(CPPFLAGS) $(LDFLAGS) -lm -o $@

test: gen_data
	dropdb --if-exists q3c_test
	createdb q3c_test
	psql q3c_test -c "CREATE TABLE test (ra double precision, dec double precision)"
	psql q3c_test -c "CREATE TABLE test1 (ra double precision, dec double precision)"
	psql q3c_test -c "CREATE TABLE test_pm0 (ra double precision, dec double precision, pmra real, pmdec real, epoch real)"
	psql q3c_test -c "CREATE TABLE test_pm1 (ra double precision, dec double precision, pmra real, pmdec real, epoch real)"
	psql q3c_test -c "CREATE TABLE test_small (ra double precision, dec double precision)"
	./gen_data 1 1000000 | psql q3c_test -c "COPY test FROM STDIN WITH DELIMITER ' '"
	./gen_data 2 1000000 | psql q3c_test -c "COPY test1 FROM STDIN WITH DELIMITER ' '"
	./gen_data 3 100000 | psql q3c_test -c "COPY test_small FROM STDIN WITH DELIMITER ' '"

	./gen_data 4 1000000 --withpm --pmscale=0 --randomepoch | psql q3c_test -c "COPY test_pm0 FROM STDIN WITH DELIMITER ' '"
	./gen_data 5 1000000 --withpm --pmscale=1000 --epoch=2015 | psql q3c_test -c "COPY test_pm1 FROM STDIN WITH DELIMITER ' '"

	psql q3c_test -c 'CREATE EXTENSION q3c'
	psql q3c_test -c 'CREATE INDEX q3c_idx1 ON test1 (q3c_ang2ipix(ra,dec))'
	psql q3c_test -c 'CREATE INdex ON test_pm0 (q3c_ang2ipix(ra,dec))'
	psql q3c_test -c 'CREATE INDEX on test_pm1 (q3c_ang2ipix(ra,dec))'
	psql q3c_test -c 'CREATE INDEX q3c_idx ON test (q3c_ang2ipix(ra,dec))'

	psql q3c_test -c 'CREATE INDEX q3c_idx_small ON test_small (q3c_ang2ipix(ra,dec))'
	psql q3c_test -c 'ANALYZE test'
	psql q3c_test -c 'ANALYZE test1'
	psql q3c_test -c 'ANALYZE test_pm0'
	psql q3c_test -c 'ANALYZE test_pm1'
	psql q3c_test -c 'ANALYZE test_small'
	mkdir -p results
	cat sql/misc.sql | psql q3c_test > results/misc.out 2>&1
	diff results/misc.out expected/misc.expected
	cat sql/ang2ipix.sql | psql q3c_test > results/ang2ipix.out 2>&1
	diff results/ang2ipix.out expected/ang2ipix.expected
	cat sql/cone.sql | psql q3c_test > results/cone.out 2>&1
	diff results/cone.out expected/cone.expected
	cat sql/cone_join_rev.sql | psql q3c_test > results/cone.out
	diff results/cone.out expected/cone.expected
	cat sql/ellipse.sql | psql q3c_test > results/ellipse.out
	diff results/ellipse.out expected/ellipse.expected
	cat sql/join.sql | psql q3c_test > results/join.out
	diff results/join.out expected/join.expected
	cat sql/join_ellipse.sql | psql q3c_test > results/join_ellipse.out
	diff results/join_ellipse.out expected/join.expected
	cat sql/join_pm1.sql | psql q3c_test > results/join_pm1.out
	diff results/join_pm1.out expected/join_pm1.expected
	cat sql/join_pm2.sql | psql q3c_test > results/join_pm2.out
	diff results/join_pm2.out expected/join_pm2.expected
	cat sql/poly.sql | psql q3c_test > results/poly.out
	diff results/poly.out expected/poly.expected
	cat sql/poly1.sql | psql q3c_test > results/poly1.out
	diff results/poly1.out expected/poly.expected
	cat sql/version.sql | psql q3c_test > results/version.out
	diff results/version.out expected/version.expected
	cat sql/area.sql | psql q3c_test > results/area.out 2>&1
	diff results/area.out expected/area.expected
	cat sql/errors.sql | psql q3c_test > results/errors.out 2>&1
	diff results/errors.out expected/errors.expected
	dropdb q3c_test
	createdb q3c_test
	psql q3c_test -c 'CREATE EXTENSION q3c VERSION "1.6.0"'
	psql q3c_test -c 'ALTER EXTENSION q3c UPDATE TO "1.7.0"'
	psql q3c_test -c 'ALTER EXTENSION q3c UPDATE TO "1.8.0"'
	psql q3c_test -c 'ALTER EXTENSION q3c UPDATE TO "2.0.0"'
	dropdb q3c_test
	createdb q3c_test
	psql q3c_test -c "CREATE TABLE test (ra double precision, dec double precision)"
	psql q3c_test -c "CREATE TABLE test1 (ra double precision, dec double precision)"
	./gen_data 1 1000000 | psql q3c_test -c "COPY test FROM STDIN WITH DELIMITER ' '"
	./gen_data 2 1000000 | psql q3c_test -c "COPY test1 FROM STDIN WITH DELIMITER ' '"

	psql q3c_test -c 'CREATE schema tests'
	psql q3c_test -c 'CREATE EXTENSION q3c schema tests'
	psql q3c_test -c 'set search_path to public,tests; CREATE INDEX q3c_idx1 ON test1 (q3c_ang2ipix(ra,dec))'
	psql q3c_test -c 'ANALYZE test'
	psql q3c_test -c 'ANALYZE test1'
	cat sql/relocation.sql | psql q3c_test > results/relocation.out
	diff results/relocation.out expected/relocation.expected
	dropdb q3c_test

=== debian/changelog ===
postgresql-q3c (2.0.1-5) unstable; urgency=medium

  * Upload for PostgreSQL 18. (Closes: #1117330)
  * Add ${postgresql:Breaks}.

 -- Christoph Berg <myon@debian.org>  Wed, 08 Oct 2025 20:03:00 +0200

postgresql-q3c (2.0.1-4) unstable; urgency=medium

  * Upload for PostgreSQL 17.
  * Restrict to 64-bit architectures.
  * Mark postgresql-all as <!nocheck>.

 -- Christoph Berg <myon@debian.org>  Sun, 15 Sep 2024 12:49:10 +0200

postgresql-q3c (2.0.1-3) unstable; urgency=medium

  * debian/rules: Use execute_before_dh_auto_install.

 -- Christoph Berg <myon@debian.org>  Wed, 07 Aug 2024 16:30:03 +0200

postgresql-q3c (2.0.1-2) unstable; urgency=medium

  * Install docs to non-generic name (Closes: #1073800)

 -- Ole Streicher <olebole@debian.org>  Mon, 05 Aug 2024 10:15:54 +0200

postgresql-q3c (2.0.1-1) unstable; urgency=medium

  * New upstream version 2.0.1.

 -- Christoph Berg <myon@debian.org>  Fri, 05 Jan 2024 14:34:58 +0100

postgresql-q3c (2.0.0-8) unstable; urgency=medium

  * Upload for PostgreSQL 16.
  * Use ${postgresql:Depends}.

 -- Christoph Berg <myon@debian.org>  Mon, 18 Sep 2023 22:00:14 +0200

postgresql-q3c (2.0.0-7) unstable; urgency=medium

  * Upload for PostgreSQL 15.

 -- Christoph Berg <myon@debian.org>  Mon, 24 Oct 2022 16:19:54 +0200

=== debian/control ===
Source: postgresql-q3c
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Ole Streicher <olebole@debian.org>,
 Markus Nullmeier <mnullmei@ari.uni-heidelberg.de>,
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-64-bit <!pkg.postgresql.32-bit>,
 postgresql-all <!nocheck>,
 postgresql-server-dev-all,
Standards-Version: 4.7.2
Homepage: http://www.sai.msu.su/~megera/wiki/SkyPixelization
Vcs-Browser: https://salsa.debian.org/postgresql/postgresql-q3c
Vcs-Git: https://salsa.debian.org/postgresql/postgresql-q3c.git

Package: postgresql-18-q3c
Architecture: any
Depends:
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
Provides:
 postgresql-q3c,
Breaks:
 ${postgresql:Breaks},
Description: PostgreSQL 18 extension used for indexing the sky
 Q3C, an extension for PostgreSQL, is designed for the work with large
 astronomical catalogues or any catalogs of objects on the sphere.
 .
 This extension allows a user to perform fast circular, elliptical or
 polygonal searches on the sky as well as fast cross-matches.

=== debian/rules ===
#!/usr/bin/make -f

override_dh_pgxs_test:
	echo "make test" | LANG=C.UTF-8 LANGUAGE= pg_buildext virtualenv . . postgresql-%v-q3c

%:
	dh $@ --with pgxs_loop

# pgxs_loop overrides dh_auto_install internally, use execute_before_ here, not override_dh_auto_install
execute_before_dh_auto_install:
	cp README.md q3c.md

=== debian/tests/control ===
Depends:
 build-essential,
 postgresql-common (>= 219~),
 @,
Tests:
 installcheck,
Restrictions:
 allow-stderr,

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/q3c-$1\.tar\.gz/ \
 https://github.com/segasai/q3c/tags .*/v?(\d\S+)\.tar\.gz

## postgresql-q3c 2.0.2

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,12 @@
 		 sed -e "s/default_version[[:space:]]*=[[:space:]]*'\([^']*\)'/\1/")
 
 
-DOCS = README.md
+# Note the filename is different from README.md
+# because of the requirement to have unique filenames
+# we create q3c.md out of README.md when compiling
+# the extension
+DOCS = q3c.md
+
 OBJS = dump.o q3c.o q3c_poly.o q3cube.o
 MODULE_big = q3c
 DATA = $(wildcard scripts/*sql)
@@ -32,21 +37,15 @@
 endif
 
 include $(PGXS)
-PGVERNEW := $(shell if [ $(MAJORVERSION) -ge 12 ] ; then echo N ; else echo O ; fi )
 
-ifeq ($(PGVERNEW), N)
-	PG_LIBS += -L$(shell $(PG_CONFIG) --pkglibdir)
-	LIBS := $(filter-out -lpam -lxml2 -lxslt -lselinux -ledit -lgssapi_krb5, $(LIBS))
-	MYBINLIBS := $(LIBS) $(PG_LIBS) -lm
-else
-	MYBINLIBS := $(PG_LIBS) -lm
-endif
+readme:
+	cp README.md q3c.md
 
-dump.c: prepare
+dump.c: prepare readme
 	./prepare
 
-prepare: prepare.o q3cube.o q3c_poly.o
-	$(CC) $? $(CFLAGS) $(PG_LIBS) $(PG_LDFLAGS) $(LDFLAGS) $(MYBINLIBS) -o $@
+prepare: prepare.c q3cube.c q3c_poly.c
+	$(CC) $(PG_CPPFLAGS) $(CFLAGS) -DQ3C_STANDALONE $^ $(LDFLAGS) -lm -o $@
 
 gen_data: gen_data.c
 	$(CC) $< $(CPPFLAGS) $(LDFLAGS) -lm -o $@

=== debian/changelog ===
postgresql-q3c (2.0.2-1) unstable; urgency=medium

  * New upstream version 2.0.2.

 -- Christoph Berg <myon@debian.org>  Sat, 21 Feb 2026 08:52:02 +0100

postgresql-q3c (2.0.1-6) unstable; urgency=medium

  * Test-Depend on postgresql-common-dev.

 -- Christoph Berg <myon@debian.org>  Wed, 12 Nov 2025 13:59:15 +0100
